<?php
/**
 * @package     ChatbotSpimob
 * @subpackage  Plugin
 *
 * @copyright   Copyright  Spimob.io. All rights reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

defined('_JEXEC') or die;
jimport('joomla.plugin.plugin');
jimport('joomla.log.log');

/**
 * ChatbotSpimob live chat plugin
 *
 * @package     ChatbotSpimob
 * @subpackage  Plugin
 * @since       1.2.1
 */
class PlgSystemSpimobChatBot extends JPlugin
{
    /**
     * Login JRoute.
     *
     * @const
     */
    //const ROUTE = 'index.php?option=com_u';

    /**
     * Joomla application
     *
     * @var  CMSApplication
     */
    protected $app;

    /**
     * Database connection.
     *
     * @var  \JDatabaseDriver
     */
    protected $db;

    /**
     * Constructor
     *
     * @param   object  $subject  The object to observe
     * @param   array   $config   An optional associative array of configuration settings.
     *                             Recognized key values include 'name', 'group', 'params', 'language'
     *                             (this list is not meant to be comprehensive).
     */
    public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage();
        $this->app = JFactory::getApplication();
        $this->db = JFactory::getDbo();
    }

    public function onAfterRender()
    {
      $app = JFactory::getApplication();
      $pubkey = $this->params->get('spimob_chatbot_apikey', '');
     
      // only insert the script in the frontend
      if ($app->isClient('site') && strlen($pubkey) > 4) {

          // retrieve all the response as an html string
          $html = $app->getBody();
          
          // replace the closing body tag with your scripts appending to the closing body tag
          $javascript = "<script src='https://code.jquery.com/jquery-3.6.0.min.js'></script>
          <script src='https://developers.chatbot.tn/assets/chatbox/chatbot.tn.js'></script>
          <script>$('body').chatbot({'uid':'".$pubkey."'});</script>";


          $html = str_replace('</body>',$javascript . '</body>',$html);

          // override the original response
          $app->setBody($html);
        }
    }
}
